#------------------------------------------------------------------ Modules
# dclaration des modules

use DBM::Deep;
use IO::Handle;
STDOUT->autoflush(1); 

#------------------------------------------------------------------ Dclaration globales
# paramtres
our $langue="fr";
our $sepDef="_";

# variables globales
our $theText;
our $definiendum;
our %sampa;

our %api;
our %dico;
our @indexdico;
our %syn;
our %hyp;
our $nbEntrees=0;

# on lie les hashes  des bases gre par le module DBM:Deep
our $db1 = tie %dico, "DBM::Deep", "dico.db";
our $db2 = tie %syn, "DBM::Deep", "syn.db";
our $db3 = tie %api, "DBM::Deep", "hyp.db";
our $db4 = tie %hyp, "DBM::Deep", "api.db";
our $db5 = tie @indexDico, "DBM::Deep", "indexDico.db";


#------------------------------------------------------------------ Main

#*************************************************
# PARSEUR XML
#*************************************************
# Appel  chaque balise ouvrante
sub startTag {
    my $elt = shift(@_);    # variable contenant le nom de la balise
    my %attr = @_;           # tableau associatif contenant attribut/valeur de la balise
	
	############### placer ici les tests concernant le traitement des balises ouvrantes
	
	
	###############
		
	
	$theText="";
}

#*************************************************
# Texte compris entre deux balises
sub text { 
	$theText = shift(@_);
}

# Appel  chaque balise de fin
sub endTag {
    my $elt = shift(@_);

	############### placer ici les tests concernant le traitement des balises fermantes
	if ($elt eq "title") {
		$definiendum=$theText;
		#~ print $definiendum."\n";
	} elsif ($elt eq "text") {
		majDico($theText);
	}
	
	###############
}

# Effectue la lecture du fichier xml, en grant les appels de startTag(), text(), endTag()
sub parseXMLFile {
    my $file = shift(@_);
	my ($ligne, $tag, $attr, $tagAttr,$avant,$dedans,$notEOF,$notEOF2);
	my $IN;
	my @listeAttr;
	
	open($IN,$file);
	my $continue=1;
    while ($continue) {
        # d'abord on limine des caractres de fin de ligne
		($avant,$notEOF)=lireJusqua("<",$IN);
		if ($notEOF) {
			($dedans,$notEOF2)=lireJusqua(">",$IN);
			if ($notEOF2) {
				if ($avant) {
					text($avant);
				}
				if ($dedans=~/^\/((.|\n)*)/) {	# lecture d'une balise fermante
					endTag($1);
				} else {
					$dedans=~/([^\s]+)(\s*)(.*)/;
					$tag=$1;
					$attr=$3;
					@listeAttr=();
					while ($attr ne "") {
						if ($attr=~/^([^=\s]+)\s*=\s*"([^"]*)"\s*(.*)/) {
							$a=$1;
							push(@listeAttr,lc($1));
							push(@listeAttr,$2);
							$attr=$3;
						} elsif ($attr=~/^([^=\s]+)\s*=\s*([^\s]*)\s*(.*)/) {
							$a=$1;
							push(@listeAttr,lc($1));
							push(@listeAttr,$2);
							$attr=$3;
						} else {
							$attr="";
						}
					}
					startTag($tag,@listeAttr); 
				}
			} else {
				die "pb de codage xml\n";
			}
		} else {
			$continue=0;
		}
	}
	close($IN);
}

# lecture sur arg2 car. par car. jusqu' la lecture du car. pass en arg1
sub lireJusqua {
	my $stopCar=shift;
	my $IN=shift;
	my ($lu,$c);
	$lu="";
	while (defined($c=getc($IN)) && ($c ne $stopCar)) {	# attention : valuation paresseuse
		$lu.=$c;
	}
	return ($lu,($c eq $stopCar));	# on renvoie la chane lu, ainsi qu'un boolen indiquant comment s'est termine la lecture
}

#*************************************************
# TRAITEMENT DICO
#*************************************************

# Fonction d'enrichissement du dictionnaire  partir d'un definiens et d'un definiendum
sub majDico {
	my $definiens=shift;
	my $record=0;
	my $numLex=0;
	my $numAccep=0;
	my ($tete,$reste,$cle,$numSyn,$continue,$numHyp);

	
	while ($definiens) {
		if ($definiens=~/^\n*(.+)\n*((\n|.)*)$/) {
			$ligneTete=$1;
			$reste=$2;
			if ($ligneTete =~ /\{\{=(..)=\}\}/) {
				$lang=$1;
				if ($lang eq $langue) { 
					$record=1;
				} else {
					$record=0;
				}
			} elsif ($ligneTete =~ /\{\{-(.+)-|$langue\}\}/) {
				$cat=$1;
			} elsif ($ligneTete =~ /\{\{-(prep|art|verb.*|nom|interj|pron.*|loc.*)-\}\}/) {
				$cat=$1;
			}
			elsif ($record) {
				if ($ligneTete =~/^#:(.*)/) {
					$cle=$definiendum.$sepDef.$numLex.$sepDef.$numAccep;
					$dico{$cle}=$dico{$cle}."#".$ligneTete;
					#~ print "		-> exemple : $ligneTete\n";
				} elsif ($ligneTete =~/^#(.*)/) {
					$numAccep++;
					$cle=$definiendum.$sepDef.$numLex.$sepDef.$numAccep;
					$dico{$cle}=$ligneTete;
					#~ print "- Definition $numAccep : $ligneTete\n : ";
				} elsif ($ligneTete=~/('''$definiendum'''|^\[\[$definiendum\]\])/) {
					$trait="";
					while ($ligneTete=~/\{\{([^}]+)\}\}/g) {
						$trait.="#".$1;
					}
					$numLex++;
					$numAccep=0;
					$cle=$definiendum.$sepDef.$numLex;
					$dico{$cle}=$cat.$trait;
					$nbEntrees++;
					print "Entre [$nbEntrees] : $cle -> $definiendum$sepDef$numLex : $cat ($trait)\n";
					
				} elsif ($ligneTete=~/\{\{API\}\} : \/(.*)\//) {
					$api{$definiendum}=$1;
					#~ print "		-> API : $1\n";					
				} elsif ($ligneTete=~/\{\{SAMPA\}\} : \/(.*)\//) {
					$sampa{$definiendum}=$1;
				} elsif ($ligneTete=~/\{\{-hypo-\}\}/) {
					$continue=1;
					while ($continue && $reste=~/(.+)((\n|.)*)/) {
						$tete=$1;
						$reste=$2;
						$numHyp=0;
						if ($tete=~/\{\{-.*-\}\}/) {
							$reste=$tete.$reste;
							$continue=0;
						} else {
							if ($tete=~/^\* (.*) \((.*)\)\s*$/) {
								$hypo{$definiendum.$sepDef.$numLex.$sepDef.$2}=$1;
							} elsif ($tete=~/^\* (.*)$/) {
								if ($numHyp) {
									$hypo{$definiendum.$sepDef.$numLex.$sepDef.$numHyp}=$1;
									#~ print "-> Hypo : $definiendum.$sepDef.$numLex.$sepDef.$numSyn: $1\n";
								} else {
									$hypo{$definiendum.$sepDef.$numLex}=$1;
									#~ print "-> Hypo : $definiendum.$sepDef.$numLex : $1\n";
								}
							} elsif ($tete=~/\((.*)\)\s*:?\s*$/) {
								$numHyp=$1;
							}
						}
					}
				} elsif ($ligneTete=~/\{{\-syn-\}\}/) {
					$continue=1;
					while ($continue && $reste=~/(.+)((\n|.)*)/) {
						$tete=$1;
						$reste=$2;
						$numSyn=0;
						if ($tete=~/\{\{-.*-\}\}/) {
							$reste=$tete.$reste;
							$continue=0;
						} else {
							if ($tete=~/^\* (.*) \(((\d|,)*)\)\s*$/) { # cas o le num d'acception serait enregistr entre ( )
								$syn{$definiendum.$sepDef.$numLex.$sepDef.$2}.="#".$1;
							} elsif ($tete=~/^\* (.*)$/) {
								if ($numSyn) { # si un numro d'acception a t pralablement enregistr
									$syn{$definiendum.$sepDef.$numLex.$sepDef.$numSyn}.="#".$1;
								} else {
									$syn{$definiendum.$sepDef.$numLex}.="#".$1;
								}
							} elsif ($tete=~/\((.*)\)\s*:?\s*$/) { # cas o le num d'acception est enregistr la ligne au dessus des synonymes
								$numSyn=$1;
							}
						}
					}
				}
			}
			$definiens=$reste;
		} else {
			$definiens="";
		}
	}
}	

# fonction destine  completer les relation symtriques ou antisymtriques enregistres dans le tableau pass en argument
sub completerRelation {
	my ($adrSyn,$adrDico)=@_;
	my ($entree1,$entree2,$num1,$num2,$lemme1,$lem1,$noAccep,$numAccep1,$numAccep2,$rec);
	my (@l,@listeSyn,$listeSyn);
	
	while (($entree1,$listeSyn)=each (%{$adrSyn})) {
		$listeSyn=supprCrochets($listeSyn);		
		@listeSyn=split(/#/,$listeSyn);
		shift @listeSyn;
		@l=split(/$sepDef/,$entree1);
		if (@l==3) {
			($lemme1,$num1,$numAccep1)=@l;
			$noAccep=0;
		} else {
			($lemme1,$num1)=@l;
			$noAccep=1;
		}
		$lem1=quotemeta($lemme1);
		foreach $lemme2 (@listeSyn) {
			$num2=1;
			while (exists($adrDico->{$lemme2.$sepDef.$num2})) {
				$rec=0;
				if (exists($adrSyn->{$lemme2.$sepDef.$num2})) {
	
					$lemmes2_1=supprCrochets($adrSyn->{$lemme2.$sepDef.$num2});
					#~ print "$lemme1 ->> $lemme2	->> $lemmes2_1\n"; 
					if ($lemmes2_1=~/$lem1/) {
						print "Cas 1 : La relation est rciproque entre $entree1 et $lemme2$sepDef$num2\n";
						$rec=1;
					}
				} 
				
				$numAccep2=1;
				while (exists($adrDico->{$lemme2.$sepDef.$num2.$sepDef.$numAccep2})) {
					if (exists($adrSyn->{$lemme2.$sepDef.$num2.$sepDef.$numAccep2})) {
						$lemmes2_1=supprCrochets($adrSyn->{$lemme2.$sepDef.$num2.$sepDef.$numAccep2});
						if ($lemmes2_1=~/$lem1/) {
							print "Cas 2 : La relation est rciproque entre $entree1 et $lemme2$sepDef$num2$sepDef$numAccep2\n";
							$rec=1;
						}
					}
					$numAccep2++;
				}
				if (!$rec) {
					print "cas 3 : la relation n'est pas rciproque entre ".$lemme1."_$num1 et ".$lemme2."_$num2\n";
				}
				$num2++;
			} 
		#~ print $entree1." - ".reformateDef($forme2)."\n";
		}
	
	}
}



# extrait les cls du dico pass en arg et en effectue un tri
sub creerIndexDico {
	my $adrDico=shift;
	print "Tri des cls\n";
	my @indexDico=sort {transformeCle($a) cmp transformeCle($b)} keys %{$adrDico};
	return @indexDico;
}

# transforme la cl pour que le tri respecte l'ordre des acceptions
sub transformeCle {
	my $cle=shift;
	my @l=split(/$sepDef/,$cle);
	my $res;
	($l[1]<1000) or die "Dpassement de taille sur la cl $cle\n";
	$res=$l[0].$sepDef.("0"x(3-length($l[1]))).$l[1];
	if (defined($l[2])) {
		($l[2]<10000) or die "Dpassement de taille sur la cl $cle\n";
		$res.=$sepDef.("0"x(4-length($l[2]))).$l[2];
	}
	return $res;
}
		

# Alaffichage des donnes du dictionnaire
# pour chaque lemme, on cree deux listes imbrique :
# niveau 1 : correspond aux "entres" (lemme+numro de cat)
# niveau 2 : correspond aux "acception" (lemme+numro de cat+ numro de def)
sub afficheDico {
	my ($adrDico,$adrIndexDico,$adrSyn)=@_;
	
	
	print "Ecriture du fichier : dico.html\n";
	open(OUT,">","dico.html");
	
	print OUT "<html>\n<head>\n<title>Wiktionnary</title>\n";
	print OUT "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
	print OUT "<style> .syn {color:red} .quoted {font-style:italic} .entree { font-weigth:bold } .note { color:blue }</style>";
	print OUT "</head><body>\n";

	print "Lecture du hash dans l'ordre des cls tries\n";
	my ($entree,@l,@def,@syn,$i);
	my $premierPassage=1;
	my $nbEntree=0;
	
	foreach $entree (@{$adrIndexDico}) {
		$nbEntree++;
		($nbEntree<10000 ) or last; # on n'affiche que les 100000 premires entres
		
		@l=split(/$sepDef/,$entree);
		if (@l==2) {
			($lemme,$num)=@l;
			if (!$premierPassage) {
				print OUT "\t\t\t</ol>\n"; # on referme la prcdente liste de niveau 2
				print OUT "\t\t</li>\n";	# on referme le dernier item de niveau 1
			}
			if ($num==1) { # on trouve un nouveau lemme
				if (!$premierPassage) {
					print OUT "\t</ol>\n";	# on referme la prcdente liste de niveau 1
				}
				print OUT "<h2>".$lemme."</h2>\n";
				print OUT "\t<ol>\n";	# on ouvre une nouvelle liste de niveau 1
			} 
			print OUT "\t\t<li>$adrDico->{$entree}<br/>\n"; # on ouvre un item de niveau 1
			if (exists($adrSyn->{$entree})) {
				@syn=split(/#/,$adrSyn->{$entree});
				shift @syn;
				@syn=map(reformateDef($_),@syn);
				print OUT "\t\t<span class=\"syn\">Synonymes</span> : ".join(", ",@syn)."<br/>\n";
			}			
			print OUT "\t\t\t<ol>\n"; # on ouvre une liste de niveau 2
		} elsif (@l==3) {
			($lemme,$num,$numAccep)=@l;
			@def=split(/##/,$adrDico->{$entree});
			print OUT "\t\t\t\t<li>\n"; # on ouvre un item de niveau 2
			print OUT "\t\t\t\t<b>$lemme\t$num\t$numAccep</b> : ".reformateDef($def[0])."<br/>\n";
			print "$lemme\t$num\t$numAccep : ".reformateDef($def[0])."\n";
			for ($i=1;$i<=$#def;$i++) {
				print OUT "\t\t\t\t\tEx. ".reformateDef($def[$i])."<br/>\n";
			}
			if (exists($adrSyn->{$entree})) {
				@syn=split(/#/,$adrSyn->{$entree});
				@syn=map(reformateDef($_),@syn); 
				shift @syn;
				print OUT "\t\t\t\t<span class=\"syn\">Synonymes</span> : ".join(", ",@syn)."<br/>";
			}
			print OUT "\t\t\t\t</li>\n";	# on referme un item de niveau 2
		} else {
			die "Problme avec la cl $entree (liste @l)\n"
		}
		$premierPassage=0;
	}
	print OUT "</body></html>\n";
	close(OUT);
}


# fonction de reformatage des sorties html
sub reformateDef {
	my $s=shift;
	$s=~s/^#//;
	$s=~s/\[\[([^\]]+\|)?([^\]]+)\]\]/$2/g; # on ne retient pas la forme lemmatise avant le |
	$s=~s/'''(.*?)'''/<span class="quoted">$1<\/span>/g;
	$s=~s/\{\{(.*?)\}\}/<span class="note">[$1]<\/span>/g;
	$s=~s/&amp;/&/g;
	
	return $s;
}

sub supprCrochets {
	my $s=shift;
	$s=~s/\[\[([^\]]+\|)?([^\]]+)\]\]/$2/g;
	return $s;
}

#==================================== EXAMEN du 12/12/2006 - Solutions

# recherche d'une locution   partir d'un patron
sub rechercherLoc {
	my ($requete,$dico,$index)=@_;
	my $trouve;
	# @listeCrits contient la liste des critres : lexmes ou CATEGORIES
	my @listeCrits=split(/ /,$requete);
	my @result;

	# on passe en revue toutes les entres listes dans l'index
	BOUCLE:foreach my $entree (@{$index}) {
		my $val=$dico->{$entree};
		# si la valeur contient la chane "loc-" c'est une locution
		if ($val=~/loc-/) {
			# on isole le lemme du numro de lexie (spar  $sepDed i.e. '_' 
			$entree=~/^([^$sepDef]+)/;
			my $loc=$1;
			# on fractionne le lemme de la locution en liste de lexme
			@listeLex=split(/ /,$loc);
			# si le nombre de lexmes correspond aux critres
			if ($#listeLex==$#listeCrits) {
				$trouve=1;
				# on parcours les critres un  un 
				for (my $i=0;$i<=$#listeLex;$i++) {
					my $crit=$listeCrits[$i];
					# si le critre correspond  une catgorie
					if ($crit=~/^[A-Z]+$/) { 
						# recherche des catgories associes au ime lexme de la locution
						my @cats=categoriesPossibles($dico,$listeLex[$i]);
						# si la catgorie ne correspond pas, la locution est  rejeter
						if (! membre(\@cats,lc($crit))) {
							$trouve=0;
							next (BOUCLE);							
						}
					} else { 
						# recherche de lexme. S'il n'est pas gal au critre, la locution est  rejeter
						if ($crit ne $listeLex[$i]) {
							$trouve=0;
							next (BOUCLE);
						}
					}
				}
			} else {
				$trouve=0;
				next (BOUCLE);					
			}
			# a priori, quand on arrive ici, c'est que la locution convient ($trouve=1). On fait le test par prudence.
			if ($trouve) {
				print "$loc\n";
				push (@result,$loc);
			} 
		}
	}
	return @result;
}

# pour un lemme, renvoie la liste des catgories possibles dans le dictionnaire
sub categoriesPossibles {
	my ($dico,$lemme)=@_;
	my @listeCats;
	my $num=1;
	
	# on teste toutes les cls susceptibles d'tre associes au lemme  : LEMME_1, LEMME_2, etc. On s'arrte quand on n'en trouve plus
	while (exists($dico->{$lemme.$sepDef.$num})) {
		my $cat_traits=$dico->{$lemme.$sepDef.$num};
		# on analyse $cat_traits pour en extraire le premier groupe de car. avant le -
		$cat_traits=~/^([^\-]+)/;
		my $cat=$1;
		# on enregistre la cat dans le rsultat
		push(@listeCats,lc($cat));
		$num++;
	}
	return @listeCats;
}

# renvoie si l'element en arg2 est membre de la liste en arg1
sub membre {
	my ($adr,$elt)=@_;
	foreach my $e (@{$adr}) {
		if ($e eq $elt) {
			return 1;
		}
	}
	return 0;
}

# fonction permettant de lister les catgories de base utilises dans le dictionnaire
sub listerCategories {
	my $dico=shift;
	my %cats;
	
	# on passe en revue tous les couples cle->valeur
	while (($entree,$val) = each (%{$dico})) {
		# si la cl n'est pas du type : xxx_yyy_zzz, alors on extrait la catgorie
		if ($entree!~/$sepDef.+$sepDef/) {
			if ($val=~/^([^\-]+)/) {
				$cat=$1;
				# on incrmente le compteur pour la catgorie
				if (exists($cats{$cat})) {
					$cats{$cat}++;
				} else {
				# la premire fois, il faut initialiser
					$cats{$cat}=1;
				}
			}
		}
	}
	# sortie de toutes les catgories tries, avec les statistiques associes
	foreach $cat (sort keys %cats) {
		print "$cat : ".$cats{$cat}."\n";
	}
}

#~ Rsultats
#~ abr : 19
#~ adj : 7846
#~ adjectif : 1
#~ adv : 1535
#~ ant : 1
#~ apr : 3
#~ art : 14
#~ conj : 22
#~ drv : 51
#~ etym : 301
#~ exp : 270
#~ flex : 119
#~ holo : 8
#~ homo : 6
#~ hypo : 29
#~ interj : 118
#~ lettre : 8
#~ loc : 4237
#~ marque : 1
#~ mero : 1
#~ nom : 26240
#~ note : 61
#~ onoma : 15
#~ ortho : 1
#~ paro : 2
#~ part : 12
#~ pp : 10
#~ pref : 89
#~ prep : 43
#~ pron : 30
#~ pronom : 83
#~ prov : 89
#~ préf : 5
#~ prénom : 4
#~ prép : 1
#~ réf : 3
#~ suf : 78
#~ symb : 25
#~ syn : 3
#~ trad : 25
#~ verb : 6312
#~ voir : 10
#~ étym : 8

# antidictionnaire : cration d'un nouvel index avec changement de l'ordre des cls
# La cl de tri correspond  l'inverse des lemmes, et  l'ordre numrique des entres et des acceptions
# attention : on change l'ordre des cls, mais on ne transforme pas les lments de la liste d'index
sub antiDic {
	my $adrIndex=shift;
	return sort {transformeCle2($a) cmp transformeCle2($b)} @{$adrIndex};
}


# transforme la cl pour que le tri respecte l'ordre des acceptions, avec inversion des lettres du lemme
# Par exemple "voiture_2_12" -> "erutiov_002_00012". 
sub transformeCle2 {
	my $cle=shift;
	my @l=split(/$sepDef/,$cle);
	my $res;
	($l[1]<1000) or die "Dpassement de taille sur la cl $cle\n";
	$res=inverse($l[0]).$sepDef.("0"x(3-length($l[1]))).$l[1];
	if (defined($l[2])) {
		($l[2]<10000) or die "Dpassement de taille sur la cl $cle\n";
		$res.=$sepDef.("0"x(4-length($l[2]))).$l[2];
	}
	return $res;
}

# renverse une chaine de caractre
sub inverse {
	my $string=shift;
	return join("",reverse(split(//,$string)));
}


#------------------------------------------------------------------ Main
# PRINCIPAL
#***********************************************************************

#~ parseXMLFile("frwiktionary.10000000.xml");
#~ parseXMLFile("frwiktionary-20061019-pages-articles.xml");

#~ @indexDico=creerIndexDico(\%dico);
#~ afficheDico(\%dico,\@indexDico,\%syn);
#~ completerRelation(\%syn,\%dico);

#~ print $dico{"bas_2"}."\n";
#~ print $dico{"de_1"}."\n";
#~ print $dico{"laine_2"}."\n";
#~ print join(",",categoriesPossibles(\%dico,"ADN"))."\n";
#~ print join(",",categoriesPossibles(\%dico,"en"))."\n";
#~ print join(",",categoriesPossibles(\%dico,"zigzag"))."\n";

#~ listerCategories(\%dico);

rechercherLoc("NOM PREP NOM",\%dico,\@indexDico);
@antiDico=antiDic(\@indexDico);